
import 'dart:io';
import 'dart:ui';

import 'package:flutter/material.dart';
import 'package:flutter/services.dart';
import 'package:nan_scan/nan_scan_channel.dart';
import 'package:nan_scan/nan_scan_page.dart';

const VIEW_TYPE = 'com.scan.widget';
class NanScanWidget extends StatefulWidget{

  final Function onResult;
  final Widget child;
  final Function customFun;
  NanScanWidget({
    Key key,
    this.onResult,
    this.child,
    this.customFun
  }):super(key: key);

  @override
  _NanScanWidgetState createState() => _NanScanWidgetState();


}
class _NanScanWidgetState extends State<NanScanWidget>{
  MethodChannel _channel;


  @override
  void initState() {
    super.initState();
  }

  @override
  void dispose() {
    super.dispose();
    NanScanMethod.disposeScan();
  }


  @override
  Widget build(BuildContext context) {

    return Stack(
      children: [
        Platform.isIOS?UiKitView(
          viewType: VIEW_TYPE,
          // onPlatformViewCreated: onPlatformViewCreated,
          // gestureRecognizers: gestureRecognizers,
          creationParams: creationParams,
          creationParamsCodec: const StandardMessageCodec(),
          onPlatformViewCreated: (id){
            _onPlatformViewCreated(id);
          },
        ):AndroidView(
          viewType: VIEW_TYPE,
          creationParams: creationParams,
          creationParamsCodec: const StandardMessageCodec(),
          onPlatformViewCreated: (id){
            _onPlatformViewCreated(id);
          },
        ),
        Offstage(
          offstage: widget.child == null,
          child: widget.child,
        )
      ],
    );
  }

  Widget openWidget(){
    return Stack(
      children: [
        Positioned(
          bottom: MediaQueryData.fromWindow(window).padding.bottom+20,
          left: (MediaQueryData.fromWindow(window).size.width-60)/2,
          child: GestureDetector(
            child: Container(
              width: 60,
              height: 60,
              alignment: Alignment.center,
              constraints: BoxConstraints(
                
              ),
              decoration: BoxDecoration(
                color: Colors.redAccent,
                boxShadow: [
                  // BoxShadow(color: Color(0x99FFFF00), offset: Offset(3.0, 3.0), blurRadius: 10.0, spreadRadius: 2.0), 
                  BoxShadow(color: Color.fromRGBO(255, 255, 255, 1), offset: Offset(0.5, 0.5)), 
                  BoxShadow(color: Color.fromRGBO(	105,105,105, 1))
                ],
                borderRadius: BorderRadius.all(Radius.circular(30))
              ),
              child: Text("开",style: TextStyle(color: Colors.white,fontSize: 20),),
            ),
            onTap: (){
              // NanScanMethod.toggleTorchMode();
              Navigator.push(context, new MaterialPageRoute(builder: (context) => new NanScanPage()));
            },
          )
        )
      ],
    );
  }

  final Map<String, dynamic> creationParams = <String, dynamic>{
      'params': "拓展",
  };

  void _onPlatformViewCreated(int id) {
    _channel = MethodChannel('nan_scan_method_$id');
    NanScanMethod.init(_channel);
    _channel?.setMethodCallHandler((MethodCall call) async {
      if (call.method == 'onCaptured') {
        if (widget.onResult != null)
          widget.onResult(call.arguments.toString());
      }
    });
  }
}